Imports System.IO
Imports System.Threading
Public Class Form1
    Inherits System.Windows.Forms.Form
    ' Beispiel-Klasse
    Private WithEvents Bsp As Example
    ' Thread zum Lesen der MP3-/Schreiben der Wave-Datei
    Private LeseThread As Thread

#Region " Vom Windows Form Designer generierter Code "

    Public Sub New()
        MyBase.New()
        Application.EnableVisualStyles()
        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Initialisierungen nach dem Aufruf InitializeComponent() hinzufgen

    End Sub

    ' Die Form berschreibt den Lschvorgang der Basisklasse, um Komponenten zu bereinigen.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Fr Windows Form-Designer erforderlich
    Private components As System.ComponentModel.IContainer

    'HINWEIS: Die folgende Prozedur ist fr den Windows Form-Designer erforderlich
    'Sie kann mit dem Windows Form-Designer modifiziert werden.
    'Verwenden Sie nicht den Code-Editor zur Bearbeitung.
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents ButtonMP3_Auswaehlen As System.Windows.Forms.Button
    Friend WithEvents ProgressBar1 As System.Windows.Forms.ProgressBar
    Friend WithEvents ButtonAbbrechen As System.Windows.Forms.Button
    Friend WithEvents Timer1 As System.Windows.Forms.Timer
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(Form1))
        Me.Label3 = New System.Windows.Forms.Label
        Me.ButtonMP3_Auswaehlen = New System.Windows.Forms.Button
        Me.ProgressBar1 = New System.Windows.Forms.ProgressBar
        Me.ButtonAbbrechen = New System.Windows.Forms.Button
        Me.Timer1 = New System.Windows.Forms.Timer(Me.components)
        Me.SuspendLayout()
        '
        'Label3
        '
        Me.Label3.Location = New System.Drawing.Point(8, 8)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(280, 48)
        Me.Label3.TabIndex = 2
        Me.Label3.Text = "Mit diesem Tool kann eine MP3- in eine Wave-Datei konvertiert werden. Die neue Wa" & _
        "ve-Datei befindet sich dann im selben Directory wie die MP3-Datei."
        '
        'ButtonMP3_Auswaehlen
        '
        Me.ButtonMP3_Auswaehlen.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.ButtonMP3_Auswaehlen.Location = New System.Drawing.Point(72, 64)
        Me.ButtonMP3_Auswaehlen.Name = "ButtonMP3_Auswaehlen"
        Me.ButtonMP3_Auswaehlen.Size = New System.Drawing.Size(136, 40)
        Me.ButtonMP3_Auswaehlen.TabIndex = 3
        Me.ButtonMP3_Auswaehlen.Text = "MP3 auswhlen..."
        '
        'ProgressBar1
        '
        Me.ProgressBar1.Location = New System.Drawing.Point(8, 112)
        Me.ProgressBar1.Name = "ProgressBar1"
        Me.ProgressBar1.Size = New System.Drawing.Size(272, 23)
        Me.ProgressBar1.TabIndex = 4
        '
        'ButtonAbbrechen
        '
        Me.ButtonAbbrechen.Location = New System.Drawing.Point(200, 144)
        Me.ButtonAbbrechen.Name = "ButtonAbbrechen"
        Me.ButtonAbbrechen.TabIndex = 5
        Me.ButtonAbbrechen.Text = "Abbrechen"
        Me.ButtonAbbrechen.Visible = False
        '
        'Timer1
        '
        Me.Timer1.Interval = 500
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(292, 181)
        Me.Controls.Add(Me.ButtonAbbrechen)
        Me.Controls.Add(Me.ProgressBar1)
        Me.Controls.Add(Me.ButtonMP3_Auswaehlen)
        Me.Controls.Add(Me.Label3)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.Name = "Form1"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "MP3 To Wave Converter"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub ButtonMP3_Auswaehlen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMP3_Auswaehlen.Click

        Dim Dlg As New OpenFileDialog
        Dlg.Filter = "MP3-Dateien (*.mp3)|*.mp3"
        Dlg.FilterIndex = 1
        Dlg.RestoreDirectory = True

        ' OpenFileDialog zum Auswahl einer MP3-Datei anzeigen
        If Dlg.ShowDialog() = DialogResult.OK Then
            Dim QuellDateiname As String = Dlg.FileName
            ' Wave-Dateiname festlegen
            Dim ZielDateiname As String = Path.GetDirectoryName(QuellDateiname) & "\" & Path.GetFileNameWithoutExtension(QuellDateiname) & ".wav"

            ' neue Instanz der Example-Klasse erstellen
            Bsp = New Example(QuellDateiname, ZielDateiname)
            ' Das Konvertieren soll im thread erfolgen, um es gegebenenfalls abzubrechen
            LeseThread = New Thread(AddressOf Bsp.Convert)
            Me.ProgressBar1.Value = 0
            LeseThread.Start()
            ' Timer starten, im 500-ms-Abstand wird Fortschrittsanzeige aktualisiert.
            Timer1.Start()

            Me.ButtonMP3_Auswaehlen.Enabled = False
            Me.ButtonAbbrechen.Visible = True
        End If
    End Sub

    Private Sub ButtonAbbrechen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonAbbrechen.Click
        ' Timer (und Fortschrittsanzeige) anhalten.
        Timer1.Stop()
        ' Konvertieren unterbrechen
        Bsp.Abort = True
        Me.ButtonMP3_Auswaehlen.Enabled = True
        Me.ButtonAbbrechen.Visible = False
        Me.ProgressBar1.Value = 0
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        ' Fortschrittsanzeige aktualisieren
        If Not IsNothing(Bsp) Then
            Me.ProgressBar1.Value = Bsp.PercentDone
        End If
    End Sub

    Private Sub Bsp_Ready() Handles Bsp.Ready
        ' Das Event Ready tritt ein, wenn die Konvertierung von MP3 zu Wave abgeschlossen ist

        ' Timer (und Fortschrittsanzeige) anhalten.
        Timer1.Stop()
        Dim S As Integer = Bsp.TS.Seconds
        Dim ms As Integer = Bsp.TS.Milliseconds Mod (S * 1000)
        ' Meldung mit Anzahl Bytes und abgelaufener Zeit anzeigen.
        MessageBox.Show(Me, "Insgesamt wurden " & Bsp.TotalBytes & " Bytes gelesen." & vbCrLf & _
        "Dauer: " & S & "," & ms & " Sekunden.", "MP3 To Wave Converter", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Me.ProgressBar1.Value = 0
        Me.ButtonMP3_Auswaehlen.Enabled = True
        Me.ButtonAbbrechen.Visible = False
    End Sub

    Private Sub Form1_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        ' Wird die Windows Form geschlossen, whrend der Konvertierungs-Thread noch luft, 
        ' muss dieser unterbrochen werden.
        Timer1.Stop()
        If Not IsNothing(Bsp) Then
            Bsp.Abort = True
        End If
    End Sub

End Class
